/* utils.c generated by valac, the Vala compiler
 * generated from utils.vala, do not modify */

/*
 * Copyright (C) 2010 Canonical Ltd
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 3 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by Mikkel Kamstrup Erlandsen <mikkel.kamstrup@canonical.com>
 *
 */

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <zeitgeist.h>
#include <dee.h>

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _UnityFilesPlaceUtilsGetIconForUriAsyncData UnityFilesPlaceUtilsGetIconForUriAsyncData;

#define UNITY_FILES_PLACE_TYPE_GROUP (unity_files_place_group_get_type ())

struct _UnityFilesPlaceUtilsGetIconForUriAsyncData {
	int _state_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	char* uri;
	char* mimetype;
	char* result;
	GFile* f;
	GFileInfo* info;
	GIcon* icon;
	char* thumbnail_path;
	GIcon* icon2;
	GError * e;
	GError * _inner_error_;
};

typedef enum  {
	UNITY_FILES_PLACE_GROUP_TOP_RESULTS,
	UNITY_FILES_PLACE_GROUP_TODAY,
	UNITY_FILES_PLACE_GROUP_YESTERDAY,
	UNITY_FILES_PLACE_GROUP_THIS_WEEK,
	UNITY_FILES_PLACE_GROUP_LAST_WEEK,
	UNITY_FILES_PLACE_GROUP_THIS_MONTH,
	UNITY_FILES_PLACE_GROUP_PAST_SIX_MONTHS,
	UNITY_FILES_PLACE_GROUP_THIS_YEAR,
	UNITY_FILES_PLACE_GROUP_LAST_YEAR
} UnityFilesPlaceGroup;



#define UNITY_FILES_PLACE_UTILS_icon_attribs G_FILE_ATTRIBUTE_PREVIEW_ICON "," G_FILE_ATTRIBUTE_STANDARD_ICON "," G_FILE_ATTRIBUTE_THUMBNAIL_PATH
char* unity_files_place_utils_get_icon_for_uri (const char* uri, const char* mimetype);
static void unity_files_place_utils_get_icon_for_uri_async_data_free (gpointer _data);
static void unity_files_place_utils_get_icon_for_uri_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
void unity_files_place_utils_get_icon_for_uri_async (const char* uri, const char* mimetype, GAsyncReadyCallback _callback_, gpointer _user_data_);
char* unity_files_place_utils_get_icon_for_uri_finish (GAsyncResult* _res_);
static gboolean unity_files_place_utils_get_icon_for_uri_async_co (UnityFilesPlaceUtilsGetIconForUriAsyncData* data);
char* unity_files_place_utils_get_month_name (GDateMonth month);
GType unity_files_place_group_get_type (void);
guint unity_files_place_utils_get_time_group (ZeitgeistEvent* event, DeeModel* groups_model);



static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


char* unity_files_place_utils_get_icon_for_uri (const char* uri, const char* mimetype) {
	char* result = NULL;
	GError * _inner_error_;
	g_return_val_if_fail (uri != NULL, NULL);
	g_return_val_if_fail (mimetype != NULL, NULL);
	_inner_error_ = NULL;
	{
		GFile* f;
		GFileInfo* info;
		char* thumbnail_path;
		f = g_file_new_for_uri (uri);
		info = g_file_query_info (f, UNITY_FILES_PLACE_UTILS_icon_attribs, G_FILE_QUERY_INFO_NONE, NULL, &_inner_error_);
		if (_inner_error_ != NULL) {
			_g_object_unref0 (f);
			goto __catch4_g_error;
		}
		thumbnail_path = g_strdup (g_file_info_get_attribute_byte_string (info, G_FILE_ATTRIBUTE_THUMBNAIL_PATH));
		if (thumbnail_path == NULL) {
			GIcon* icon;
			icon = _g_object_ref0 (g_file_info_get_icon (info));
			result = g_strdup (g_icon_to_string (icon));
			_g_object_unref0 (icon);
			_g_object_unref0 (f);
			_g_object_unref0 (info);
			_g_free0 (thumbnail_path);
			return result;
		} else {
			GFileIcon* _tmp1_;
			GFile* _tmp0_;
			char* _tmp2_;
			result = (_tmp2_ = g_strdup (g_icon_to_string ((GIcon*) (_tmp1_ = (GFileIcon*) g_file_icon_new (_tmp0_ = g_file_new_for_path (thumbnail_path))))), _g_object_unref0 (_tmp1_), _g_object_unref0 (_tmp0_), _tmp2_);
			_g_object_unref0 (f);
			_g_object_unref0 (info);
			_g_free0 (thumbnail_path);
			return result;
		}
		_g_object_unref0 (f);
		_g_object_unref0 (info);
		_g_free0 (thumbnail_path);
	}
	goto __finally4;
	__catch4_g_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			GIcon* icon2;
			icon2 = _g_object_ref0 (g_content_type_get_icon (mimetype));
			result = g_strdup (g_icon_to_string (icon2));
			_g_error_free0 (e);
			_g_object_unref0 (icon2);
			return result;
		}
	}
	__finally4:
	{
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


static void unity_files_place_utils_get_icon_for_uri_async_data_free (gpointer _data) {
	UnityFilesPlaceUtilsGetIconForUriAsyncData* data;
	data = _data;
	_g_free0 (data->uri);
	_g_free0 (data->mimetype);
	_g_free0 (data->result);
	g_slice_free (UnityFilesPlaceUtilsGetIconForUriAsyncData, data);
}


void unity_files_place_utils_get_icon_for_uri_async (const char* uri, const char* mimetype, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	UnityFilesPlaceUtilsGetIconForUriAsyncData* _data_;
	_data_ = g_slice_new0 (UnityFilesPlaceUtilsGetIconForUriAsyncData);
	_data_->_async_result = g_simple_async_result_new (g_object_newv (G_TYPE_OBJECT, 0, NULL), _callback_, _user_data_, unity_files_place_utils_get_icon_for_uri_async);
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, unity_files_place_utils_get_icon_for_uri_async_data_free);
	_data_->uri = g_strdup (uri);
	_data_->mimetype = g_strdup (mimetype);
	unity_files_place_utils_get_icon_for_uri_async_co (_data_);
}


char* unity_files_place_utils_get_icon_for_uri_finish (GAsyncResult* _res_) {
	char* result;
	UnityFilesPlaceUtilsGetIconForUriAsyncData* _data_;
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
	result = _data_->result;
	_data_->result = NULL;
	return result;
}


static void unity_files_place_utils_get_icon_for_uri_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	UnityFilesPlaceUtilsGetIconForUriAsyncData* data;
	data = _user_data_;
	data->_res_ = _res_;
	unity_files_place_utils_get_icon_for_uri_async_co (data);
}


static gboolean unity_files_place_utils_get_icon_for_uri_async_co (UnityFilesPlaceUtilsGetIconForUriAsyncData* data) {
	switch (data->_state_) {
		case 0:
		goto _state_0;
		case 4:
		goto _state_4;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	{
		{
			data->f = g_file_new_for_uri (data->uri);
			data->_state_ = 4;
			g_file_query_info_async (data->f, UNITY_FILES_PLACE_UTILS_icon_attribs, G_FILE_QUERY_INFO_NONE, G_PRIORITY_LOW, NULL, unity_files_place_utils_get_icon_for_uri_async_ready, data);
			return FALSE;
			_state_4:
			data->info = g_file_query_info_finish (data->f, data->_res_, &data->_inner_error_);
			if (data->_inner_error_ != NULL) {
				_g_object_unref0 (data->f);
				goto __catch5_g_error;
			}
			data->icon = _g_object_ref0 (g_file_info_get_icon (data->info));
			data->thumbnail_path = g_strdup (g_file_info_get_attribute_byte_string (data->info, G_FILE_ATTRIBUTE_THUMBNAIL_PATH));
			if (data->thumbnail_path == NULL) {
				data->result = g_strdup (g_icon_to_string (data->icon));
				_g_object_unref0 (data->f);
				_g_object_unref0 (data->info);
				_g_object_unref0 (data->icon);
				_g_free0 (data->thumbnail_path);
				{
					if (data->_state_ == 0) {
						g_simple_async_result_complete_in_idle (data->_async_result);
					} else {
						g_simple_async_result_complete (data->_async_result);
					}
					g_object_unref (data->_async_result);
					return FALSE;
				}
			} else {
				data->result = data->thumbnail_path;
				_g_object_unref0 (data->f);
				_g_object_unref0 (data->info);
				_g_object_unref0 (data->icon);
				{
					if (data->_state_ == 0) {
						g_simple_async_result_complete_in_idle (data->_async_result);
					} else {
						g_simple_async_result_complete (data->_async_result);
					}
					g_object_unref (data->_async_result);
					return FALSE;
				}
			}
			_g_object_unref0 (data->f);
			_g_object_unref0 (data->info);
			_g_object_unref0 (data->icon);
			_g_free0 (data->thumbnail_path);
		}
		goto __finally5;
		__catch5_g_error:
		{
			data->e = data->_inner_error_;
			data->_inner_error_ = NULL;
			{
				data->icon2 = _g_object_ref0 (g_content_type_get_icon (data->mimetype));
				data->result = g_strdup (g_icon_to_string (data->icon2));
				_g_error_free0 (data->e);
				_g_object_unref0 (data->icon2);
				{
					if (data->_state_ == 0) {
						g_simple_async_result_complete_in_idle (data->_async_result);
					} else {
						g_simple_async_result_complete (data->_async_result);
					}
					g_object_unref (data->_async_result);
					return FALSE;
				}
				_g_error_free0 (data->e);
				_g_object_unref0 (data->icon2);
			}
		}
		__finally5:
		{
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, data->_inner_error_->message, g_quark_to_string (data->_inner_error_->domain), data->_inner_error_->code);
			g_clear_error (&data->_inner_error_);
			return FALSE;
		}
	}
	{
		if (data->_state_ == 0) {
			g_simple_async_result_complete_in_idle (data->_async_result);
		} else {
			g_simple_async_result_complete (data->_async_result);
		}
		g_object_unref (data->_async_result);
		return FALSE;
	}
}


char* unity_files_place_utils_get_month_name (GDateMonth month) {
	char* result = NULL;
	switch (month) {
		case G_DATE_BAD_MONTH:
		{
			result = g_strdup ("Invalid Month");
			return result;
		}
		case G_DATE_JANUARY:
		{
			result = g_strdup ("January");
			return result;
		}
		case G_DATE_FEBRUARY:
		{
			result = g_strdup ("February");
			return result;
		}
		case G_DATE_MARCH:
		{
			result = g_strdup ("March");
			return result;
		}
		case G_DATE_APRIL:
		{
			result = g_strdup ("April");
			return result;
		}
		case G_DATE_MAY:
		{
			result = g_strdup ("May");
			return result;
		}
		case G_DATE_JUNE:
		{
			result = g_strdup ("June");
			return result;
		}
		case G_DATE_JULY:
		{
			result = g_strdup ("July");
			return result;
		}
		case G_DATE_AUGUST:
		{
			result = g_strdup ("August");
			return result;
		}
		case G_DATE_SEPTEMBER:
		{
			result = g_strdup ("September");
			return result;
		}
		case G_DATE_OCTOBER:
		{
			result = g_strdup ("October");
			return result;
		}
		case G_DATE_NOVEMBER:
		{
			result = g_strdup ("November");
			return result;
		}
		case G_DATE_DECEMBER:
		{
			result = g_strdup ("December");
			return result;
		}
	}
	result = g_strdup ("Internal Error");
	return result;
}


guint unity_files_place_utils_get_time_group (ZeitgeistEvent* event, DeeModel* groups_model) {
	guint result = 0U;
	gint64 t;
	gint64 now;
	gint64 limit;
	GDate date = {0};
	g_return_val_if_fail (event != NULL, 0U);
	g_return_val_if_fail (groups_model != NULL, 0U);
	t = zeitgeist_event_get_timestamp (event);
	now = zeitgeist_timestamp_for_now ();
	limit = zeitgeist_timestamp_prev_midnight (now);
	if (t > limit) {
		result = (guint) UNITY_FILES_PLACE_GROUP_TODAY;
		return result;
	} else {
		if (t > (limit - ZEITGEIST_TIMESTAMP_DAY)) {
			result = (guint) UNITY_FILES_PLACE_GROUP_YESTERDAY;
			return result;
		}
	}
	memset (&date, 0, sizeof (GDate));
	zeitgeist_timestamp_to_date (now, &date);
	limit = limit - ((g_date_get_weekday (&date) - 1) * ZEITGEIST_TIMESTAMP_DAY);
	if (t > limit) {
		result = (guint) UNITY_FILES_PLACE_GROUP_THIS_WEEK;
		return result;
	} else {
		if (t > (limit - ZEITGEIST_TIMESTAMP_WEEK)) {
			result = (guint) UNITY_FILES_PLACE_GROUP_LAST_WEEK;
			return result;
		}
	}
	g_date_set_day (&date, (GDateDay) 1);
	limit = zeitgeist_timestamp_from_date (&date);
	if (t > limit) {
		result = (guint) UNITY_FILES_PLACE_GROUP_THIS_MONTH;
		return result;
	}
	g_date_subtract_months (&date, (guint) 1);
	limit = zeitgeist_timestamp_from_date (&date);
	if (t > (now - ((6 * 30) * ZEITGEIST_TIMESTAMP_DAY))) {
		result = (guint) UNITY_FILES_PLACE_GROUP_PAST_SIX_MONTHS;
		return result;
	}
	zeitgeist_timestamp_to_date (now, &date);
	g_date_set_month (&date, G_DATE_JANUARY);
	g_date_set_day (&date, (GDateDay) 1);
	limit = zeitgeist_timestamp_from_date (&date);
	if (t > limit) {
		result = (guint) UNITY_FILES_PLACE_GROUP_THIS_YEAR;
		return result;
	} else {
		result = (guint) UNITY_FILES_PLACE_GROUP_LAST_YEAR;
		return result;
	}
}




